﻿

Public Class Form_Main

    '' ============================================================================================================
    ''   PREVENT FORM FLICKERING -  With style WS_EX_COMPOSITED
    ''   With that style turned on, Windows XP does double-buffering on the form and all its child controls. 
    '' ============================================================================================================
    'Protected Overrides ReadOnly Property CreateParams() As CreateParams
    '    Get
    '        Dim cp As CreateParams = MyBase.CreateParams
    '        cp.ExStyle = cp.ExStyle Or 33554432
    '        Return cp
    '    End Get
    'End Property
    '' ============================================================================================================


    Friend WithEvents m_MruList As MruList
    Private Const APP_NAME As String = "Theremino_Script"

    ' -----------------------------------------------------------------------------------------------------
    '  FORM and BUTTONS
    ' -----------------------------------------------------------------------------------------------------
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Left = 200
        Top = 200
        ' ----------------------------------------------------------------- 
        '   please respect the following calling order
        ' -----------------------------------------------------------------
        Editor_Init(Me, RTB_Script, LV_Errors, TabControl_Reports, TXT_RuntimeErrors, StatusLabel1, ImageList_Suggestions)

        LoadUserOptions()
        CorrectSplitterBug()
        Me.Text = AppTitleAndVersion()

        ' ---------------------------------------- no run in memory
        'Menu_RunInMemory.Visible = False
        Tool_Run.Visible = False
        ' --------------------------------------------------------------
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        Show()

        Editor_InitialReload()
        UpdateCaption()
        m_MruList = New MruList(APP_NAME, Menu_File, 6)

        ' Todo remove
        ' -----------------------------------------------
        'Dim b As System.Windows.Forms.Button = Nothing
        'My.Computer.Audio.Stop()
        ' -----------------------------------------------
        EventsAreEnabled = True
    End Sub

    Private Sub Form_Main_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Timer1.Stop()
        SaveUserOptions()
        If Not Editor_OkToGo("Closing application") Then
            e.Cancel = True
            Exit Sub
        End If
        ' --------------------------------------- force other forms to close
        End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub


    ' =======================================================================================================
    '   APP TITLE AND VERSION
    ' =======================================================================================================
    Friend Function AppTitleAndVersion(Optional ByVal Title As String = "") As String
        If Title = "" Then Title = Replace(My.Application.Info.AssemblyName, "_", " ")
        Dim s() As String = Split(My.Application.Info.Version.ToString, ".")
        Return Title & " - V" & s(0) & "." & s(1)
    End Function
    Private Sub UpdateCaption()
        Me.Text = AppTitleAndVersion() & "   """ & IO.Path.GetFileName(Editor_FileName) & """"
    End Sub


    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.FromArgb(230, 230, 230), _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub


    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' ===================================================================================
    ' A SplitContainer bug increases by 2 pixel the "Form.Width" and the "SplitDistance"
    ' This sub imposes a granularity of 4 pixel and stops the derive
    ' ===================================================================================
    Private Sub CorrectSplitterBug()
        Me.Width = 4 * CInt(Me.Width \ 4)
        SplitContainer1.SplitterDistance = 4 * CInt(SplitContainer1.SplitterDistance \ 4)
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  TIMER
    ' -----------------------------------------------------------------------------------------------------
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        UpdateEnables()
    End Sub

    Private Sub UpdateEnables()
        Dim en As Boolean
        '
        en = Editor_Modified And Not Editor_RunningCode
        Menu_Save.Enabled = en
        Tool_Save.Enabled = en
        '
        en = Editor_IsTextselected() And Not Editor_RunningCode
        Menu_Cut.Enabled = en
        Menu_Copy.Enabled = en
        Menu_Delete.Enabled = en
        Tool_Cut.Enabled = en
        Tool_Copy.Enabled = en
        CTX_Edit_Cut.Enabled = en
        CTX_Edit_Copy.Enabled = en
        CTX_Edit_Delete.Enabled = en
        CTX_Edit_SearchWithGoogle.Enabled = en
        CTX_Edit_SearchWithBing.Enabled = en
        CTX_Edit_SearchWithMSDN.Enabled = en
        '
        en = Editor_CanPaste() And Not Editor_RunningCode
        Menu_Paste.Enabled = en
        Tool_Paste.Enabled = en
        CTX_Edit_Paste.Enabled = en
        '
        en = Editor_CanUndo() And Not Editor_RunningCode
        Menu_Undo.Enabled = en
        Tool_Undo.Enabled = en
        '
        en = Editor_CanRedo() And Not Editor_RunningCode
        Menu_Redo.Enabled = en
        Tool_Redo.Enabled = en
        '
        en = (Compiler_ErrorCount = 0) And Not Editor_RunningCode
        Menu_BuildDLL.Enabled = en
        Menu_BuildExe.Enabled = en
        Menu_BuildExeAndRun.Enabled = en
        Menu_RunInMemory.Enabled = en
        Tool_BuildDll.Enabled = en
        Tool_BuildExe.Enabled = en
        Tool_BuildExeAndRun.Enabled = en
        Tool_Run.Enabled = en
        '
        en = Not Editor_RunningCode
        Menu_File.Enabled = en
        Menu_Edit.Enabled = en
        Menu_Build.Enabled = en
        Menu_Tools.Enabled = en
        Menu_HelpRoot.Enabled = en
        Tool_Indent.Enabled = en
        Tool_UnIndent.Enabled = en
        Tool_Comment.Enabled = en
        Tool_Uncomment.Enabled = en
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  MAIN MENU
    ' -----------------------------------------------------------------------------------------------------
    Private Sub Menu_NewVB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_NewVB.Click
        Editor_NewVB()
        UpdateCaption()
    End Sub
    Private Sub Menu_NewCSharp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_NewCSharp.Click
        Editor_NewCS()
        UpdateCaption()
    End Sub
    Private Sub Menu_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Open.Click
        Editor_Open()
        UpdateCaption()
    End Sub
    Private Sub Menu_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Save.Click
        Editor_Save()
        UpdateCaption()
    End Sub
    Private Sub Menu_SaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_SaveAs.Click
        Editor_SaveAs()
        UpdateCaption()
    End Sub
    Private Sub Menu_OpenApplicationFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_OpenApplicationFolder.Click
        System.Diagnostics.Process.Start(Application.StartupPath)
    End Sub
    Private Sub Menu_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Exit.Click
        Me.Close()
    End Sub
    Private Sub m_MruList_OpenFile(ByVal filename As String) Handles m_MruList.OpenFile
        Editor_Open(filename)
        UpdateCaption()
    End Sub

    Private Sub Menu_Undo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Undo.Click
        Editor_Undo()
    End Sub
    Private Sub Menu_Redo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Redo.Click
        Editor_Redo()
    End Sub
    Private Sub Menu_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Cut.Click
        Editor_Cut()
    End Sub
    Private Sub Menu_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Copy.Click
        Editor_Copy()
    End Sub
    Private Sub Menu_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Paste.Click
        Editor_Paste()
    End Sub
    Private Sub Menu_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Delete.Click
        Editor_Delete()
    End Sub
    Private Sub Menu_SelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_SelectAll.Click
        Editor_SelectAll()
    End Sub
    Private Sub Menu_Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Find.Click
        Editor_Find()
    End Sub
    Private Sub Menu_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Replace.Click
        Editor_FindReplace()
    End Sub

    Private Sub BuildDLLToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_BuildDLL.Click
        Editor_CompileDll()
    End Sub
    Private Sub BuildExeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_BuildExe.Click
        Editor_CompileExeFile(False)
    End Sub
    Private Sub BuildExeFileAndRunToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_BuildExeAndRun.Click
        Editor_CompileExeFile(True)
    End Sub
    Private Sub RunInMemoryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_RunInMemory.Click
        Compiler_RunInMemory(Nothing)
    End Sub

    Private Sub Menu_Options_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Options.Click
        Editor_ShowOptions(Me)
    End Sub
    Private Sub Menu_RemoveEmptyLines_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_RemoveEmptyLines.Click
        Editor_RemoveEmptyLines()
    End Sub
    Private Sub Menu_InsertResxFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_InsertResxFile.Click
        Editor_InsertResxFile()
    End Sub

    Private Sub Menu_Help_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help.Click
        Form_Help.ShowDialog()
    End Sub
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  TOOL STRIP
    ' -----------------------------------------------------------------------------------------------------
    Private Sub Tool_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Open.Click
        Editor_Open()
        UpdateCaption()
    End Sub
    Private Sub Tool_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Save.Click
        Editor_Save()
    End Sub
    Private Sub Tool_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Cut.Click
        Editor_Cut()
    End Sub
    Private Sub Tool_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Copy.Click
        Editor_Copy()
    End Sub
    Private Sub Tool_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Paste.Click
        Editor_Paste()
    End Sub
    Private Sub Tool_Undo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Undo.Click
        Editor_Undo()
    End Sub
    Private Sub Tool_Redo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Redo.Click
        Editor_Redo()
    End Sub
    Private Sub Tool_Indent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Indent.Click
        Editor_Indent()
    End Sub
    Private Sub Tool_UnIndent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_UnIndent.Click
        Editor_UnIndent()
    End Sub
    Private Sub Tool_Comment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Comment.Click
        Editor_Comment()
    End Sub
    Private Sub Tool_Uncomment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Uncomment.Click
        Editor_UnComment()
    End Sub

    Private Sub Tool_Build_DLL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_BuildDll.Click
        Editor_CompileDll()
    End Sub
    Private Sub Tool_BuildExe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_BuildExe.Click
        Editor_CompileExeFile(False)
    End Sub
    Private Sub Tool_BuildExeAndRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_BuildExeAndRun.Click
        Editor_CompileExeFile(True)
    End Sub
    Private Sub Tool_Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Run.Click
        Compiler_RunInMemory(Nothing)
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  CONTEXTUAL MENU - EDITOR
    ' -----------------------------------------------------------------------------------------------------
    Private Sub CTX_Edit_GoToDefinition_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_GoToDefinition.Click
        Editor_GotoDefinition()
    End Sub
    Private Sub CTX_Edit_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Cut.Click
        Editor_Cut()
    End Sub
    Private Sub CTX_Edit_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Copy.Click
        Editor_Copy()
    End Sub
    Private Sub CTX_Edit_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Paste.Click
        Editor_Paste()
    End Sub
    Private Sub CTX_Edit_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Delete.Click
        Editor_Delete()
    End Sub
    Private Sub CTX_Edit_SelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_SelectAll.Click
        Editor_SelectAll()
    End Sub
    Private Sub CTX_Edit_Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Find.Click
        Editor_Find()
    End Sub
    Private Sub CTX_Edit_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Replace.Click
        Editor_FindReplace()
    End Sub
    Private Sub CTX_Edit_SearchWithGoogleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_SearchWithGoogle.Click
        System.Diagnostics.Process.Start("http://www.google.com/search?q=" & LanguageString() & RTB_Script.SelectedText)
    End Sub
    Private Sub CTX_Edit_SearchWithBingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_SearchWithBing.Click
        System.Diagnostics.Process.Start("http://www.bing.com/search?q=" & LanguageString() & RTB_Script.SelectedText)
    End Sub
    Private Sub CTX_Edit_SearchWithMSDNToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_SearchWithMSDN.Click
        System.Diagnostics.Process.Start("http://social.msdn.microsoft.com/Search/it-IT/?query=" & LanguageString() & RTB_Script.SelectedText & "&ac=8")
    End Sub
    Private Function LanguageString() As String
        Select Case Compiler_Language
            Case Compiler_Languages.VB : Return "Vb.Net "
            Case Compiler_Languages.CSharp : Return "C# "
            Case Else : Return ""
        End Select
    End Function

    ' -----------------------------------------------------------------------------------------------------
    '  CONTEXTUAL MENU - ERRORS
    ' -----------------------------------------------------------------------------------------------------
    Private Sub CTX_Errors_CopyToClipBoard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Errors_CopyToClipBoard.Click
        Clipboard.Clear()
        Clipboard.SetData(System.Windows.Forms.DataFormats.Text, GetSelectedError())
    End Sub
    Private Sub CTX_Errors_Search_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Errors_SearchGoogle.Click
        System.Diagnostics.Process.Start("http://www.google.com/search?q=" & GetSelectedErrorCode())
    End Sub
    Private Sub CTX_Errors_SearchBingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Errors_SearchBingToolStripMenuItem.Click
        System.Diagnostics.Process.Start("http://www.bing.com/search?q=" & GetSelectedErrorCode()) '& "&go=&form=QBLH&filt=all")
    End Sub
    Private Sub CTX_Errors_SearchMSDNToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Errors_SearchMSDNToolStripMenuItem.Click
        System.Diagnostics.Process.Start("http://social.msdn.microsoft.com/Search/it-IT/?query=" & GetSelectedErrorCode() & "&ac=8")
    End Sub
    Private Function GetSelectedError() As String
        If LV_Errors.SelectedItems.Count = 1 Then
            Return LV_Errors.SelectedItems(0).SubItems(1).Text
        Else
            Return ""
        End If
    End Function
    Private Function GetSelectedErrorCode() As String
        If LV_Errors.SelectedItems.Count = 1 Then
            Return LV_Errors.SelectedItems(0).SubItems(1).Text.Substring(0, 8)
        Else
            Return ""
        End If
    End Function

End Class







