' ================================================================================================
'  Theremino System - Rele Receiver V3 
' ------------------------------------------------------------------------------------------------
'  - ENG - 
'  This Is only a simulator for testing the signals. The actual program Is the "ReleDriver"
'  This script simulates a shift register that controls a bank of relays (Or other devices)
'  Signals are sent from a Master Module with four shielded wires: ENABLE, DATA, CLOCK And 5Volt
' ------------------------------------------------------------------------------------------------
'  - ITA - 
'  Questo è solo un simulatore per provare i segnali. Il programma operativo è il "ReleDriver"
'  Questo script simula uno shift register che pilota un banco di relè (o di altri dispositivi) 
'  Il pilotaggio arriva dal Master con cavo schermato a quattro fili: ENABLE, DATA, CLOCK e 5VOLT
' ================================================================================================

Const NumRele As Int32 = 16					' Rele number			- Numero di RELE (8,16,24...)

Const SlotEnable As Int32 = 1				' Slot ENABLE			- Slot del filo ENABLE
Const SlotData As Int32 = 2					' Slot DATA				- Slot del filo DATA
Const SlotClock As Int32 = 3				' Slot CLOCK			- Slot del filo CLOCK


' ================================================================================================
'  - ENG - THE SIMPLIFIED MANAGEMENT ENDS HERE - MODIFY THE FOLLOWING CAREFULLY
' ------------------------------------------------------------------------------------------------
'  - ITA - LA GESTIONE SEMPLIFICATA FINISCE QUI - MODIFICARE LA PARTE SEGUENTE CON ATTENZIONE
' ================================================================================================

' ------------------------------------------------------------------------------------------------
'  Main Loop
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	timeBeginPeriod(1)
	StartThread
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	timeEndPeriod(1)
	Timer1.Stop
	objThread.Abort
End Sub

Sub StartThread()
	' --------------------------------------------------------- asynchronously start the Thread 
	objThread = New Threading.Thread(AddressOf ExecuteThread)
	' --------------------------------------------------------- make the thread As background thread.
	objThread.IsBackground = True
	' --------------------------------------------------------- Set the Priority of the thread.
	objThread.Priority = Threading.ThreadPriority.Highest
	' --------------------------------------------------------- start the thread.
	objThread.Start()
End Sub

Sub ExecuteThread
	Do
		MainThread
		Threading.Thread.Sleep(1)
	Loop Until False
End Sub

Sub PauseMS(ByVal mS As Int32)
	Threading.Thread.Sleep(mS)
End Sub

Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	TimedUpdate
End Sub

' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim objThread As Threading.Thread
Dim Label1 As Label = New Label
Dim Label2 As Label = New Label

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Rele Receiver V3"
	Form1.ClientSize = New System.Drawing.Size(460, 50)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.BackColor = Color.White
	Label1.Location = New Point(10, 10)
	Label1.Font = New Font("Arial", 18)
	Label1.Size = New Size(form1.ClientSize.Width - 20, 30)
	Label1.Anchor = AnchorStyles.top Or AnchorStyles.Left Or AnchorStyles.right
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 50
	Timer1.Start
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub

' ------------------------------------------------------------------------------------------------
' This Function Is executed more Then 100 times per second by a separate Thread
' Funzione eseguita più di 100 volte al secondo In un thread separato 
' ------------------------------------------------------------------------------------------------
Dim ShiftData As String = StrDup(NumRele, "0")
Dim NewEnable As Single
Dim NewData As Single
Dim NewClock As Single
Dim OldClock As Single

Sub MainThread()
	NewEnable = ReadSlot(SlotEnable)
	NewClock = ReadSlot(SlotClock)
	NewData = ReadSlot(SlotData)
	If NewClock <> OldClock Then
		OldClock = NewClock
		If NewClock <> 0 Then
			If NewData = 0 Then
				ShiftData = "0" & Left(ShiftData, ShiftData.Length-1) 
			Else
				ShiftData = "1" & Left(ShiftData, ShiftData.Length-1)
			End If
		End If
	End If
End Sub

' ------------------------------------------------------------------------------------------------
' This Function Is executed 20 times per second (no pauses here Or the whole program Is locked)
' Funzione eseguita 20 volte al sec. ( niente pause qui altrimenti tutto il programma si blocca)
' ------------------------------------------------------------------------------------------------
Sub TimedUpdate
	If NewEnable = 0 Then
		Label1.Text = ""
	Else
		Label1.Text = ShiftData
	End If
End Sub


' ===============================================================
'  WINDOWS SCHEDULER PRECISION
' =============================================================== 
Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32


